unit u_net_dbx_apply_updates;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXpress, FMTBcd, Borland.Vcl.Db, Borland.Vcl.SqlExpr,
  Borland.Vcl.StdCtrls, System.ComponentModel, Borland.Vcl.DBClient,
  Borland.Vcl.Provider, Borland.Vcl.Grids, Borland.Vcl.DBGrids,
  Borland.Vcl.ExtCtrls;

type 
  TForm2 = class(TForm)
    SQLConnection1: TSQLConnection;
    SQLQuery1: TSQLQuery;
    DataSetProvider1: TDataSetProvider;
    ClientDataSet1: TClientDataSet;
    Panel2: TPanel;
    Panel1: TPanel;
    DataSource1: TDataSource;
    load_cds_: TButton;
    apply_updates_: TButton;
    Memo1: TMemo;
    SQLMonitor1: TSQLMonitor;
    DBGrid1: TDBGrid;
    open_cds_: TButton;
    close_cds_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure load_cds_Click(Sender: TObject);
    procedure apply_updates_Click(Sender: TObject);
    procedure close_cds_Click(Sender: TObject);
    procedure SQLMonitor1LogTrace(Sender: TObject;
      var CBInfo: SQLTRACEDesc);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ClientDataSet1ReconcileError(DataSet: TCustomClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
    procedure open_cds_Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

    implementation
      uses u_c_net_display, u_c_net_log;

    {$R *.nfm}

    const k_table_name= 'formations_4';
          k_save_dataset_name= '..\_data\save_formation.xml';

    procedure TForm2.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm2.load_cds_Click(Sender: TObject);
      begin
        ClientDataset1.LoadFromFile(k_save_dataset_name);
      end; // load_cds_Click

    procedure TForm2.apply_updates_Click(Sender: TObject);
      var l_error_count: Integer;
      begin
        display('> ApplyUpdates');
        l_error_count:= ClientDataset1.ApplyUpdates(-1);
        display('< ApplyUpdates '+ IntToStr(l_error_count));
      end; // apply_updates_Click

    procedure TForm2.close_cds_Click(Sender: TObject);
      begin
        ClientDataset1.Close;
      end; // close_cds_Click

    var g_trace_count: Integer= 0;

    procedure TForm2.SQLMonitor1LogTrace(Sender: TObject;
        var CBInfo: SQLTRACEDesc);
      begin
        with SQLMonitor1, TraceList do
          while g_trace_count< Count do
          begin
            display(Strings[g_trace_count]);
            Inc(g_trace_count);
          end;
      end; // SQLMonitor1LogTrace

    procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        close_cds_Click(Nil);
      end; // FormClose

    procedure TForm2.ClientDataSet1ReconcileError(
        DataSet: TCustomClientDataSet; E: EReconcileError;
        UpdateKind: TUpdateKind; var Action: TReconcileAction);
      begin
        display('reconcile '+ e.Message);
        // action:= HandleReconcileError(DataSet, UpdateKind, e);
      end; // ClientDataSet1ReconcileError

procedure TForm2.open_cds_Click(Sender: TObject);
      begin
        ClientDataset1.Open;
      end; // open_cds_Click

end.


